'* Filename    : SPI                                                  *
'* Revision    : 1.0                                                           *
'* Controller  : ATMEGA8                                                       *
'* Compiler    : BASCOM-AVR 2.0.7.1                                            *
'* Author      : MACTEPOK                                                      *
'*******************************************************************************

$regfile = "m8def.dat"       ' 
$crystal = 1000000  ' 
'$sim
'$lib "mcsbyte.lbx"                                          '  
$hwstack = 40
$swstack = 16
$framesize = 32

Config Portb = Output

Ds Alias Portb.2    '  
St_cp Alias Portb.1 '  
Sh_cp Alias Portb.0 ' 

'-------------------------------------------------------------------------------
Declare Sub Zapis   '     
Declare Sub Destroy '     
'-------------------------------------------------------------------------------
'*******************************************************************************

Dim Out_word(4) As Word       '     
Dim N As Byte
Dim Chislo(16) As Byte       '     
Dim Text_message(16) As Byte       '     
Dim Blink_count As Byte       '     
Dim Blinkcount_flag As Bit       '     ---------------------------------:   1    2    3    4
Dim Point_flag As Word       ' ,   .        : &B 0000 0000 0000 0000                                       '
Dim Blink_flag As Word       ' ,   .     : &B 0000 0000 0000 0000
Dim Text_flag As Word       ' ,      
Dim Invblink_flag As Bit       '    Bit
Dim Indicator_type As Byte       '   ( = 0;  <> 0)

Const Blinker = 3   ' ~ 1      
'DEMO
Dim Blinker_count As Byte       ' 
Dim Point_count As Byte
Const Shifter1 = 50 '     
Const Shifter2 = 10 '      
                                      '
Out_word(1) = 111
Out_word(2) = 2222
Out_word(3) = 3333
Out_word(4) = 4444

Point_flag = &B0000000000000001       '     
Blink_flag = &B1000000000000000       '    
Text_flag = &B1000010000100001       '      
For N = 1 To 16
   Text_message(n) = 11       '       
Next

Config Timer0 = Timer , Prescale = 256 : On Timer0 Timers       '   0        
Enable Interrupts : Enable Timer0 : Start Timer0       '  
Do
   For N = 1 To 4   '    
      Incr Out_word(n)
      If Out_word(n) > 9999 Then Out_word(n) = 0
   Next
   Call Destroy
   Call Zapis       '       16 
   Waitms 50
Loop

'
'-------------------------------------------------------------------------------
Sub Destroy         '      
   Local I As Byte
   Local M As Byte
   Local K As Byte  '   
   Local L As Byte  '   (      )
   Local Cod_var As Byte       '    Byte
   Local Copy_print As Integer       '    Integer
   K = 0            ' 
   M = 0
   For L = 4 To 1 Step -1       '   
      Copy_print = Out_word(l)       '    
      For I = 4 To 1 Step -1       '      44 = 16  ()
         Incr K
         Cod_var = Copy_print Mod 10       '       (    10)
         If Text_flag.m = 1 Then       '     ,    
            Chislo(k) = Text_message(k)       '         
         Else       ' 
            Chislo(k) = Cod_var       '     
         End If
         Incr M
         Copy_print = Copy_print / 10
      Next
   Next
End Sub
'
'-------------------------------------------------------------------------------
Sub Zapis           '     
   Local I As Byte
   Local K As Byte  '   
   Local L As Byte  '   (      )
   Local Cod_var As Byte       '    Byte

   For L = 16 To 1 Step -1
      K = L         '        Point_flag
      Decr K
      Cod_var = Lookup(chislo(l) , Cody)       '     
      If Indicator_type = 0 Then       '    
         Invblink_flag = Point_flag.k       '      
         Toggle Invblink_flag       ' 
         If Text_flag.k = 0 Then Cod_var.5 = Invblink_flag       '       h
         If Blink_flag.k = 1 And Blinkcount_flag = 1 Then Cod_var = &B11111111       '   ,  
      Else
         If Blink_flag.k = 1 And Blinkcount_flag = 1 Then Cod_var = &B00000000       '   ,  
         If Text_flag.k = 0 Then Cod_var.5 = Point_flag.k       '       h
      End If
      For I = 0 To 7       '       
         If Cod_var.7 = 0 Then Ds = 0 Else Ds = 1       '   ()    0,   0   . (   .        ,    !)
         Sh_cp = 1  '          (  )
         Sh_cp = 0
         Shift Cod_var , Left , 1       '        
      Next
      Ds = 0
   Next
   St_cp = 1        '  
   St_cp = 0
End Sub
'
'   Timer0
'-------------------------------------------------------------------------------
Timers:
   Incr Blink_count '  
   If Blink_count = Blinker Then       '   
      Toggle Blinkcount_flag       '    
      Blink_count = 0       ' 
   End If
'DEMO
   Incr Blinker_count : Incr Point_count
   If Blinker_count = Shifter1 Then       '       
      Shift Blink_flag , Right , 1
      Blinker_count = 0
   End If
   If Point_count = Shifter2 Then       '        
      Shift Point_flag , Left , 1
      Point_count = 0
   End If
Return
'-------------------------------------------------------------------------------
'  
'-------------------------------------------------------------------------------
Cody:               ' A     &B dehc abfg
Data &B00100001     '0 - "0"      a
Data &B11101011     '1 - "1"     --
Data &B00110010     '2 - "2"   f|  |b
Data &B01100010     '3 - "3"    | g|
Data &B11101000     '4 - "4"     --
Data &B01100100     '5 - "5"   e|  |c
Data &B00100100     '6 - "6"    |  |
Data &B11100011     '7 - "7"     -- h
Data &B00100000     '8 - "8"      d
Data &B01100000     '9 - "9"
Data &B11111111     '10 - ""
' :
Data &B10110100     '11 - "F"
' ..

